<template>
  <div>
    <span v-if="displayDays > 0">{{ displayDays }}:</span>{{ displayHours }}:{{ displayMin }}:{{
      displaySec
    }}
  </div>
</template>

<script>
export default {
  name: 'TimerCount',
  data: () => ({
    initial: '',
    displayDays: 0,
    displayHours: 0,
    displayMin: 0,
    displaySec: 0,
  }),

  props: {
    initialDate: { type: String, default: '' },
    endDate: { type: String, default: '' },
  },

  computed: {
    _seconds: () => 1000,
    _minutes() {
      return this._seconds * 60
    },
    _hours() {
      return this._minutes * 60
    },
    _days() {
      return this._hours * 24
    },
  },

  created() {
    let actualDate = new Date() // tem q vir do SERVIDOR - nao permite usuario alterar data
    this.initial = new Date(actualDate.getTime())
  },

  mounted() {
    this.showRemaining()
  },

  watch: {
    displaySec() {
      let refreshTime = this.initial.getTime() + 1000
      this.initial = new Date(refreshTime)

      if (
        this.displayDays == 0 &&
        this.displayHours == 0 &&
        this.displayMin == 0 &&
        this.displaySec == 2
      ) {
        this.$emit('timeEnd')
      }
    },
  },

  methods: {
    formatNum: (num) => (num < 10 ? '0' + num : num),

    showRemaining() {
      const timer = setInterval(() => {
        // const now = new Date()
        const now = this.initial
        const end = new Date(this.endDate)
        const distance = end.getTime() - now.getTime()

        if (distance < 0) {
          clearInterval(timer)
          return
        }

        const days = Math.floor(distance / this._days)
        const hours = Math.floor((distance % this._days) / this._hours)
        const minutes = Math.floor((distance % this._hours) / this._minutes)
        const seconds = Math.floor((distance % this._minutes) / this._seconds)
        this.displayMin = this.formatNum(minutes)
        this.displaySec = this.formatNum(seconds)
        this.displayHours = this.formatNum(hours)
        this.displayDays = this.formatNum(days)
      }, 1000)
    },
  },
}
</script>

<style></style>
